package com.tzld.piaoquan.wecom.job;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.tzld.piaoquan.wecom.dao.mapper.UserMapper;
import com.tzld.piaoquan.wecom.model.po.User;
import com.tzld.piaoquan.wecom.utils.HttpClientUtil;
import com.tzld.piaoquan.wecom.utils.HttpPoolClient;
import org.apache.commons.lang3.ObjectUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

@Component
public class WeComUserDataJob {

    String GET_USER_URL = "https://open.weibanzhushou.com/open-api/external_user/list";

    private static final HttpPoolClient httpPoolClientDefault = HttpClientUtil.create(30000, 30000, 2000, 5000, 5, 30000);

    final int size = 30;

    @Autowired
    private UserMapper userMapper;

    public void insertAllUser() {
        Long endTime = System.currentTimeMillis() / 1000;
        int sum = 0;
        for (int i = 0; i < 5; i++) {
            String res = null;
            try {
                //TODO accessToken 暂时写死 后续增加接口刷新和存储
                res = getUser("12c11f5504cecdc89210070ccfd72461", size, i * size, 1720540800L, endTime);
                //TODO 记录查询数据 info日志
            } catch (IOException e) {
                //TODO 记录异常日志 记录起止时间和页数 startTime endTime i
                e.printStackTrace();
            }
            if (ObjectUtils.isEmpty(res)) {
                continue;
            }
            JSONObject jsonObject = JSONObject.parseObject(res);
            Integer total = (Integer) jsonObject.get("total");
            JSONArray jsonArray = jsonObject.getJSONArray("external_user_list");
            for (int j = 0; j < jsonArray.size(); j++) {
                String id = (String) jsonArray.getJSONObject(j).get("id");
                jsonArray.getJSONObject(j).put("id", null);
                User user = jsonArray.getJSONObject(j).toJavaObject(User.class);
                user.setExternalUserId3rdParty(id);
                //TODO 记录对象数据  info日志
                int insert = userMapper.insert(user);
                if (insert <= 0) {
                    //TODO  异常日志
                    continue;
                }
                sum++;
            }
            if (jsonArray.size() < size) {
                if (total != null && total > sum) {
                    //TODO 输出异常  插入数量不足
                    System.out.println("插入数量不足");
                }
                break;
            }
        }


    }

    public String getUser(String accessToken, Integer limit, Integer offset, Long startTime, Long endTime) throws IOException {
        String url = GET_USER_URL
                + "?access_token=" + accessToken
                + "&limit=" + limit + "&offset=" + offset + "&start_time=" + startTime + "&end_time=" + endTime;
        return httpPoolClientDefault.get(url);
    }


}
